/********************************** (C) COPYRIGHT *******************************
* File Name          : HSPI.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/01/22
* Description        : CH56xHSPIز
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.h"                                                               /* ͷļ */
#include "TEST2.h"

/******************************************************************************/
/*  */
#if( DEF_HSPI_MODE == DEF_HSPI_HOST_MODE )
#define HPSI_DMA_TX_Addr0          0x20021000                                   /* HSPIDMA0ַ */
#define HPSI_DMA_TX_Addr1          HPSI_DMA_TX_Addr0 + DEF_HSPI_DMA_PACK_LEN    /* HSPIDMA1ַ */
#define HPSI_DMA_RX_Addr0          0x2002D000                                   /* HSPIDMA0ַ */
#define HPSI_DMA_RX_Addr1          HPSI_DMA_RX_Addr0 + DEF_HSPI_DMA_PACK_LEN    /* HSPIDMA1ַ */
#else
#define HPSI_DMA_TX_Addr0          0x20020000                                   /* HSPIDMA0ַ */
#define HPSI_DMA_TX_Addr1          HPSI_DMA_TX_Addr0 + DEF_HSPI_DMA_PACK_LEN    /* HSPIDMA1ַ */
#define HPSI_DMA_RX_Addr0          0x20021000                                   /* HSPIDMA0ַ */
#define HPSI_DMA_RX_Addr1          HPSI_DMA_RX_Addr0 + DEF_HSPI_DMA_PACK_LEN    /* HSPIDMA1ַ */
#endif

volatile UINT8  HSPI_Tx_PackCnt = 0x00;											/* HSPIͰ */
volatile UINT8  HSPI_Tx_AddrTog = 0x00;                                         /* HSPIͰַͬ */
volatile UINT8  HSPI_Tx_Status = 0x00;                                          /* HSPI״̬ */
volatile UINT8  HSPI_Tx_ErrFlag = 0x00;                                         /* HSPIʹ־ */
volatile UINT8  HSPI_Tx_BurstPackNum = 0x00;                                    /* HSPIͱͻ */

volatile UINT8  HSPI_Rx_PackCnt = 0x00;											/* HSPIհ */
volatile UINT8  HSPI_Rx_AddrTog = 0x00;                                         /* HSPIհַͬ */
volatile UINT8  HSPI_Rx_ErrFlag = 0x00;                                         /* HSPIմ־ */

volatile UINT32 HSPI_Test_PackCount = 0x00;

volatile UINT32 Pic_TotalLen = 0x00;                                            /* ͼƬܳ */
volatile UINT32 Pic_SendLen = 0x00;                                             /* ͼƬѷͳ */
volatile UINT32 Pic_Last_PackLen = 0x00;                                        /* ͼƬĩβͳ */
volatile UINT32 Pack_Send_Num = 0x00;
volatile UINT32 Pack_Recv_Num = 0x00;
volatile UINT8 Cmd_Start = 0x00;
volatile UINT8 YUV_Count = 0x00;
volatile UINT8 g_ColorFill=0;
volatile UINT8 g_ColorIndex=0;
UINT8  Check_Data_Buf[ 256 ];
UINT32  Color_Elemnt[ 6 ]={0x7223d423,0x88a82ca8,0x34853f85,0x80b480b4,0xd4336d33,0xcc3fc13f}; //     Ʒ
/*******************************************************************************
* Function Name  : HSPI_GPIO_Init
* Description    : HSPIӿGPIOʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_GPIO_Init( void )
{
    /* HTCLK(PA11)HTREQ(PA9)HTVLD(PA21)HTACK(PA10)Ϊ,Ϊ16mA */
    R32_PA_DIR |= ( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );
	R32_PA_DRV |= ( ( 1 << 11 ) );
	R32_PA_PU &= ~( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );
	R32_PA_PD &= ~( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );

    /* HTRDY(PA23)HRCLK(PA19)HRACK(PA18)HRVLD(PA6)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );
    R32_PA_PU &= ~( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );
    R32_PA_PD |= ( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );

    /*  HD0(PA6) HD1(PA4) HD2(PA22) HD3(PA3)  HD4(PA2)  HD5(PA1)  HD6(PA0)  HD7(PB21)
           HD8(PB20) HD9(PB19)HD10(PB18)HD11(PB17)HD12(PA17)HD13(PB16)HD14(PB15)HD15(PB14)
           HD16(PB0) HD17(PB1)HD18(PB2) HD19(PA20)HD20(PB3) HD21(PB4) HD22(PB5) HD23(PB6)
           HD24(PA16)HD25(PB7)HD26(PB8) HD27(PB9) HD28(PB10)HD29(PB11)HD30(PB12)HD31(PB13)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                     ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );
    R32_PA_PU &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                    ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );
    R32_PA_PD &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                    ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );

    R32_PB_DIR &= 0xFFC00000;
    R32_PB_PU &= 0xFFC00000;
    R32_PB_PD &= 0xFFC00000;
}

/*******************************************************************************
* Function Name  : HSPI_Init
* Description    : HSPIӿڳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_Init( void )
{
    UINT16 i;

	/* ùģʽ */
    R8_HSPI_CFG &= ~( RB_HSPI_MODE | RB_HSPI_MSK_SIZE );
#if( DEF_HSPI_MODE == DEF_HSPI_HOST_MODE )
       R8_HSPI_CFG |= RB_HSPI_MODE;
#else
    R8_HSPI_CFG &= ~( RB_HSPI_MODE );
#endif

    /* λ */
#if( DEF_HSPI_DATASIZE == DEF_HSPI_DATASIZE_8 )
	R8_HSPI_CFG |= RB_HSPI_DAT8_MOD;

#elif( DEF_HSPI_DATASIZE == DEF_HSPI_DATASIZE_16 )
	R8_HSPI_CFG |= RB_HSPI_DAT16_MOD;

#elif( DEF_HSPI_DATASIZE == DEF_HSPI_DATASIZE_32 )
	R8_HSPI_CFG |= RB_HSPI_DAT32_MOD;
#endif

    /* ACk mode 1(ӲԶӦģʽ ͻģʽ,ģʽ) */
	R8_HSPI_CFG |= RB_HSPI_HW_ACK;

    /* Tx ToG En */
    R8_HSPI_CFG |= RB_HSPI_TX_TOG_EN;

    /* Rx ToG En */
    R8_HSPI_CFG |= RB_HSPI_RX_TOG_EN;

    /* λʾ˫DMA,øλǰDMAٲ,ﵽٵЧ,32λģʽһҪд */
    R8_HSPI_AUX |= ( 1 << 5 );

	/* TX(½ز ) */
	R8_HSPI_AUX |= RB_HSPI_TCK_MOD;

	/* ӲAuto ACK time*/
	R8_HSPI_AUX |= RB_HSPI_ACK_TX_MOD;

	/* ʱʱ(ӳ2T) */
	R8_HSPI_AUX &= ~RB_HSPI_ACK_CNT_SEL;

    /* Clear ALL_CLR And TRX_RST */
	R8_HSPI_CTRL &= ~( RB_HSPI_ALL_CLR | RB_HSPI_TRX_RST );

    /* DMA TX/RX Addr0/1 */
	R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0;
	R32_HSPI_RX_ADDR0 = HPSI_DMA_RX_Addr0;
	R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1;
	R32_HSPI_RX_ADDR1 = HPSI_DMA_RX_Addr1;

    /* DMA TX/RX Len */
	R16_HSPI_DMA_LEN0 = DEF_HSPI_DMA_PACK_LEN - 1;
	R16_HSPI_DMA_LEN1 = DEF_HSPI_DMA_PACK_LEN - 1;

//	R16_HSPI_BURST_CFG |= (1<<8)|RB_HSPI_BURST_EN;
    if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
    {
        R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
    }
    R8_HSPI_RX_SC = 0x00;
    if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
    {
        R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
    }
    R8_HSPI_TX_SC = 0x00;

	/* Enable HSPI  DMA */
	R8_HSPI_CTRL |= RB_HSPI_ENABLE | RB_HSPI_DMA_EN;

    /*  TX Զ  Header */
    R32_HSPI_UDF0 = DEF_HSPI_UDF0;
    R32_HSPI_UDF1 = DEF_HSPI_UDF1;

    /* Enable Interupt */
    R8_HSPI_INT_EN |= RB_HSPI_IE_T_DONE;
    R8_HSPI_INT_EN |= RB_HSPI_IE_FIFO_OV;
    R8_HSPI_INT_EN |= RB_HSPI_IE_B_DONE;
    R8_HSPI_INT_EN |= RB_HSPI_IE_R_DONE;
    R8_HSPI_INT_FLAG = 0x0F;

    PFIC_EnableIRQ( HSPI_IRQn );

    for( i = 0; i < 256; i++ )
    {
        Check_Data_Buf[ i ] = i;
    }
}

/*******************************************************************************
* Function Name  : HSPI_IRQHandler
* Description    : HSPIӿжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HSPI_IRQHandler (void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HSPI_IRQHandler( void )
{
    UINT32V i,j;
    UINT32V addr;
    UINT32V packnum;

    if( R8_HSPI_INT_FLAG & RB_HSPI_IF_T_DONE )
    {
        /* ж */
        R8_HSPI_INT_FLAG = RB_HSPI_IF_T_DONE;

		/* رл */
        HSPI_Tx_PackCnt++;
        HSPI_Tx_AddrTog++;
        if( HSPI_Tx_AddrTog % 2 )
        {
            R32_HSPI_TX_ADDR0 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
        }
        else
        {
            R32_HSPI_TX_ADDR1 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
        }

        /* жϵǰǷĩβ */
        if( ( HSPI_Tx_BurstPackNum < DEF_HSPI_UVC_BPACK_NUM ) && ( HSPI_Tx_PackCnt == HSPI_Tx_BurstPackNum - 2 ) )
        {
            R32_HSPI_UDF0 = Pic_Last_PackLen | ( 1 << 13 );
            R32_HSPI_UDF1 = Pic_Last_PackLen | ( 1 << 13 );
            if( YUV_Count ==(YUV_FRAME_SIZE / UVC_MICROFRAME_SIZE)-1 )          /*жһ֡ͼƬǷ */
            {
                R32_HSPI_UDF0 |= Pic_Last_PackLen | ( 1 << 14 );
                R32_HSPI_UDF1 |= Pic_Last_PackLen | ( 1 << 14 );
            }
        }
	}
    else if( R8_HSPI_INT_FLAG & RB_HSPI_IF_R_DONE )
	{
		/* ж */
		R8_HSPI_INT_FLAG = RB_HSPI_IF_R_DONE;  

        /* HRTS֪ͨԷͣһݷ */
        PIN_HRTS_HIGH( );

		/* жCRCǷȷжϰǷƥ */
		if( R8_HSPI_RTX_STATUS & RB_HSPI_CRC_ERR )
		{  
			/* CRCУ */
			DUG_PRINTF("CRC Err:%d\r\n",(UINT16)HSPI_Rx_PackCnt);
			
			/* DMAַر */
            R32_HSPI_RX_ADDR0 = HPSI_DMA_RX_Addr0;
            R32_HSPI_RX_ADDR1 = HPSI_DMA_RX_Addr1;
            if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
            {
                R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
            }
            /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
            R8_HSPI_RX_SC = 0x00;
            HSPI_Rx_AddrTog = 0x00;
            HSPI_Rx_PackCnt = 0x00;
        }
		else if( R8_HSPI_RTX_STATUS & RB_HSPI_NUM_MIS )
		{  
			/* кŲƥ */
            DUG_PRINTF("NUM_MIS Err:%d\r\n",(UINT16)HSPI_Rx_PackCnt);

			/* DMAַر */
            R32_HSPI_RX_ADDR0 = HPSI_DMA_RX_Addr0;
            R32_HSPI_RX_ADDR1 = HPSI_DMA_RX_Addr1;
            if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
            {
                R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
            }

            /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
            R8_HSPI_RX_SC = 0x00;
            HSPI_Rx_AddrTog = 0x00;
            HSPI_Rx_PackCnt = 0x00;
        }
		else
		{
			/* CRCȷкƥ */

			/* رл */            
            HSPI_Rx_PackCnt++;
            HSPI_Rx_AddrTog++;
            if( HSPI_Rx_AddrTog % 2 )
            {
                R32_HSPI_RX_ADDR0 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
            }
            else
            {
                R32_HSPI_RX_ADDR1 += ( DEF_HSPI_DMA_PACK_LEN * 2 );
            }

            /* жǷյĩβ */
            if( ( R32_HSPI_UDF0 & ( 1 << 13 ) ) || ( R32_HSPI_UDF1 & ( 1 << 13 ) ) )
            {
  #if 0
                 /* ӡ */
                 printf("KK222\n");

                 addr = HPSI_DMA_RX_Addr0;
                 for( i = 0; i < HSPI_Rx_PackCnt * ( DEF_HSPI_DMA_PACK_LEN / 1024 ); i++ )
                 {
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 0 ) ));
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 1 ) ));
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 2 ) ));
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 3 ) ));
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 4 ) ));
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 5 ) ));
                     printf("%02x ",(UINT16)( *(UINT8 *)( addr + 6 ) ));
                     printf("%02x\n",(UINT16)( *(UINT8 *)( addr + 7 ) ));
                     addr += 1024;
                 }
  #endif

  #if 0
                 /*  */
                 addr = HPSI_DMA_RX_Addr0;
                 for( i = 0; i < DEF_HSPI_BURST_PACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                 {
                     if( ( *(UINT8 *)( addr + 4 ) != 0x04 ) || ( *(UINT8 *)( addr + 5 ) != 0x05 ) ||
                         ( *(UINT8 *)( addr + 6 ) != 0x06 ) || ( *(UINT8 *)( addr + 7 ) != 0x07 ) ||
                         ( *(UINT8 *)( addr + 1020 ) != 0xFC ) || ( *(UINT8 *)( addr + 1021 ) != 0xFD ) ||
                         ( *(UINT8 *)( addr + 1022 ) != 0xFE ) || ( *(UINT8 *)( addr + 1023 ) != 0xFF ) )
                     {
                         printf("KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK222 Error\n");
                         for( j = 0; j < 32; j++ )
                         {
                             printf("%02x ",(UINT16)( *(UINT8 *)( addr + j ) ));
                         }
                         printf("\n");
                     }
                     addr += 1024;
                 }
  #endif

  #if 0
                  /*  */
                  addr = HPSI_DMA_RX_Addr0;
                  for( i = 0; i < DEF_HSPI_BURST_PACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                  {
                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      addr += 256;

                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      addr += 256;

                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      addr += 256;

                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      addr += 256;
                  }
  #endif

#if 0
                /* ȫ */
                addr = HPSI_DMA_RX_Addr0;
                for( i = 0; i < DEF_HSPI_BURST_PACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                {
                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;

                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;

                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;

                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;
                }
#endif

#if 1
                /* еİ */
                addr = HPSI_DMA_RX_Addr0;
                for( i = 0; i < DEF_HSPI_BULK_BPACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                {
                    packnum = ( ( UINT32 )( *(UINT8 *)( addr + 0 ) )) << 24;
                    packnum += ( ( UINT32 )( *(UINT8 *)( addr + 1 ) ) ) << 16;
                    packnum += ( ( UINT32 )( *(UINT8 *)( addr + 2 ) ) )<< 8;
                    packnum += ( ( UINT32 )( *(UINT8 *)( addr + 3 ) ) );

                    if( packnum != Pack_Recv_Num )
                    {
                        printf("NUM2: 0x%08lx---0x%08lx\n",(UINT32)packnum,(UINT32)Pack_Recv_Num);
                    }
                    Pack_Recv_Num++;
                    addr += 1024;
                }
#endif

                /* : յHSPIܳ */
                Dbg_HSPI_Rx_TLen += ( HSPI_Rx_PackCnt - 1 ) * DEF_HSPI_DMA_PACK_LEN;
                if( R32_HSPI_UDF0 & ( 1 << 13 ) )
                {
                    Dbg_HSPI_Rx_TLen += ( R32_HSPI_UDF0 & 0x00000FFF );
                    if( ( R32_HSPI_UDF0 & 0x00000FFF ) == 0x00 )
                    {
                        Dbg_HSPI_Rx_TLen += DEF_HSPI_DMA_PACK_LEN;
                    }
                }
                else if( R32_HSPI_UDF1 & ( 1 << 13 ) )
                {
                    Dbg_HSPI_Rx_TLen += ( R32_HSPI_UDF1 & 0x00000FFF );
                    if( ( R32_HSPI_UDF1 & 0x00000FFF ) == 0x00 )
                    {
                        Dbg_HSPI_Rx_TLen += DEF_HSPI_DMA_PACK_LEN;
                    }
                }

                printf("HSPI_Rx_PackCnt:%x\n",(UINT16)HSPI_Rx_PackCnt);
                printf("R32_HSPI_UDF0:%x\n",(UINT16)R32_HSPI_UDF0);
                printf("R32_HSPI_UDF1:%x\n",(UINT16)R32_HSPI_UDF1);

                 /* DMAַر */
                 R32_HSPI_RX_ADDR0 = HPSI_DMA_RX_Addr0;
                 R32_HSPI_RX_ADDR1 = HPSI_DMA_RX_Addr0 + DEF_HSPI_DMA_PACK_LEN;

                 /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
                 if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
                 {
                     R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
                 }
                 R8_HSPI_RX_SC = 0x00;
                 HSPI_Rx_PackCnt = 0x00;

                 /* ԶĴ */
                 R32_HSPI_UDF0 = 0x00;
                 R32_HSPI_UDF1 = 0x00;

                 /* ֪ͨHSPIԷһ */
                 PIN_HRTS_LOW( );
              }
              else if( HSPI_Rx_PackCnt >= DEF_HSPI_BULK_BPACK_NUM )
              {
   #if 0
                  /* ӡ */
                  printf("K111\n");

                  addr = HPSI_DMA_RX_Addr0;
                  for( i = 0; i < HSPI_Rx_PackCnt * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                  {
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 0 ) ));
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 1 ) ));
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 2 ) ));
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 3 ) ));
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 4 ) ));
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 5 ) ));
                      printf("%02x ",(UINT16)( *(UINT8 *)( addr + 6 ) ));
                      printf("%02x\n",(UINT16)( *(UINT8 *)( addr + 7 ) ));
                      addr += 1024;
                  }
   #endif

  #if 0
                  /* ݲ */
                  addr = HPSI_DMA_RX_Addr0;
                  for( i = 0; i < DEF_HSPI_BURST_PACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                  {
                      if( ( *(UINT8 *)( addr + 4 ) != 0x04 ) || ( *(UINT8 *)( addr + 5 ) != 0x05 ) ||
                          ( *(UINT8 *)( addr + 6 ) != 0x06 ) || ( *(UINT8 *)( addr + 7 ) != 0x07 ) ||
                          ( *(UINT8 *)( addr + 1020 ) != 0xFC ) || ( *(UINT8 *)( addr + 1021 ) != 0xFD ) ||
                          ( *(UINT8 *)( addr + 1022 ) != 0xFE ) || ( *(UINT8 *)( addr + 1023 ) != 0xFF ) )
                      {
                          printf("KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK111 Error\n");
                          for( j = 0; j < 32; j++ )
                          {
                              printf("%02x ",(UINT16)( *(UINT8 *)( addr + j ) ));
                          }
                          printf("\n");
                      }
                      addr += 1024;
                  }
  #endif

  #if 0
                  /*  */
                  addr = HPSI_DMA_RX_Addr0;
                  for( i = 0; i < DEF_HSPI_BURST_PACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                  {
                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      if( *(UINT32 *)( addr + 0xFC ) != 0xFFFEFDFC )
                      {
                          printf("addr %08lx = 0x%08lx---0xFFFEFDFC\n",(UINT32)(addr + 0xFC),(UINT32)( *(UINT32 *)( addr + 0xFC )));
                      }
                      addr += 256;

                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      if( *(UINT32 *)( addr + 0xFC ) != 0xFFFEFDFC )
                      {
                          printf("addr %08lx = 0x%08lx---0xFFFEFDFC\n",(UINT32)(addr + 0xFC),(UINT32)( *(UINT32 *)( addr + 0xFC )));
                      }
                      addr += 256;

                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      if( *(UINT32 *)( addr + 0xFC ) != 0xFFFEFDFC )
                      {
                          printf("addr %08lx = 0x%08lx---0xFFFEFDFC\n",(UINT32)(addr + 0xFC),(UINT32)( *(UINT32 *)( addr + 0xFC )));
                      }
                      addr += 256;

                      if( *(UINT32 *)( addr + 4 ) != 0x07060504 )
                      {
                          printf("addr %08lx = 0x%08lx---0x07060504\n",(UINT32)(addr + 0x04),(UINT32)( *(UINT32 *)( addr + 4 )));
                      }
                      if( *(UINT32 *)( addr + 8 ) != 0x0B0A0908 )
                      {
                          printf("addr %08lx = 0x%08lx---0x0B0A0908\n",(UINT32)(addr + 0x08),(UINT32)( *(UINT32 *)( addr + 0x08 )));
                      }
                      if( *(UINT32 *)( addr + 0x0C ) != 0x0F0E0D0C )
                      {
                          printf("addr %08lx = 0x%08lx---0x0F0E0D0C\n",(UINT32)(addr + 0x0C),(UINT32)( *(UINT32 *)( addr + 0x0C )));
                      }
                      if( *(UINT32 *)( addr + 0xFC ) != 0xFFFEFDFC )
                      {
                          printf("addr %08lx = 0x%08lx---0xFFFEFDFC\n",(UINT32)(addr + 0xFC),(UINT32)( *(UINT32 *)( addr + 0xFC )));
                      }
                      addr += 256;
                  }
  #endif

#if 0
                /* ȫ */
                addr = HPSI_DMA_RX_Addr0;
                for( i = 0; i < DEF_HSPI_BULK_BPACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                {
                    j = memcmp( &Check_Data_Buf[ 4 ], (const void *)( addr + 4 ), 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;

                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;

                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;

                    j = memcmp( Check_Data_Buf, (const void *)addr, 16 );
                    if( j )
                    {
                        for( j = 0; j < 256; j++ )
                        {
                            if( *(UINT8 *)( addr + j ) != j )
                            {
                                printf("addr %08lx = 0x%08lx---0x%08lx\n",(UINT32)(addr + j),(UINT32)( *(UINT8 *)( addr + j )), (UINT16)j);
                            }
                        }
                    }
                    addr += 256;
                }
#endif

                /* еİ */
#if( DEF_FUN_PACK_SN_EN == 0x01 )
                addr = HPSI_DMA_RX_Addr0;
                for( i = 0; i < DEF_HSPI_BULK_BPACK_NUM * DEF_HSPI_DMA_PACK_LEN / 1024; i++ )
                {
                    packnum = ( ( UINT32 )( *(UINT8 *)( addr + 0 ) )) << 24;
                    packnum += ( ( UINT32 )( *(UINT8 *)( addr + 1 ) ) ) << 16;
                    packnum += ( ( UINT32 )( *(UINT8 *)( addr + 2 ) ) )<< 8;
                    packnum += ( ( UINT32 )( *(UINT8 *)( addr + 3 ) ) );
                    if( packnum != Pack_Recv_Num )
                    {
                        printf("NUM1: 0x%08lx---0x%08lx\n",(UINT32)packnum,(UINT32)Pack_Recv_Num);
                    }
                    Pack_Recv_Num++;
                    addr += 1024;
                }
#endif

                /* : յHSPIܳ */
                Dbg_HSPI_Rx_TLen += ( DEF_HSPI_BULK_BPACK_NUM * DEF_HSPI_DMA_PACK_LEN );

                /* DMAַر */
                R32_HSPI_RX_ADDR0 = HPSI_DMA_RX_Addr0;
                R32_HSPI_RX_ADDR1 = HPSI_DMA_RX_Addr0 + DEF_HSPI_DMA_PACK_LEN;

                /* ն˳CRCMIS,ҪRB_HSPI_RX_NUM */
                if( ( R8_HSPI_RX_SC & RB_HSPI_RX_TOG ) == RB_HSPI_RX_TOG )
                {
                    R8_HSPI_RX_SC = RB_HSPI_RX_TOG;
                }
                R8_HSPI_RX_SC = 0x00;
                HSPI_Rx_PackCnt = 0x00;

                /* ͨתIOڲʱ */
                HSPI_Test_PackCount++;
                if( HSPI_Test_PackCount % 1024 == 0 )
                {
                    GPIOB_InverseBits( ( 1 << 24 ) );
                }
                /* ֪ͨHSPIԷһ */
                PIN_HRTS_LOW( );
            }
		}
	}
    if( R8_HSPI_INT_FLAG & RB_HSPI_IF_B_DONE )
    {
		/* ͻģʽ,ͻа */
        R8_HSPI_INT_FLAG = RB_HSPI_IF_B_DONE;

		/* ȽʵʷͰõͻǷһ */
		if( HSPI_Tx_PackCnt != ( R16_HSPI_BURST_CFG >> 8 ) )
		{
            DUG_PRINTF("BURST Tx Err:%d\r\n",HSPI_Tx_PackCnt);
            DUG_PRINTF("R8_HSPI_TX_SC:%d\r\n",R8_HSPI_TX_SC);

            /* DMAַر */
            R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0;
            R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1;
            if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
            {
                R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
            }
            R8_HSPI_TX_SC = 0x00;
            HSPI_Tx_PackCnt = 0x00;
            HSPI_Tx_AddrTog = 0x00;

            /* ñʹ־ */
            HSPI_Tx_ErrFlag = 0x01;
		}
		else
		{
            /* DMAַر */
            R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0;
            R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1;
            if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
            {
                R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
            }
            R8_HSPI_TX_SC = 0x00;
            HSPI_Tx_AddrTog = 0x00;
            YUV_Count++;
            if( YUV_Count == (YUV_FRAME_SIZE / UVC_MICROFRAME_SIZE))           //һͼ
            {
                YUV_Count=0;
                g_ColorFill++;
            }
            /* ñɱ־ */
            HSPI_Tx_Status = 0x02;
		}
    }
	else if( R8_HSPI_INT_FLAG & RB_HSPI_IF_FIFO_OV )
	{
		/* FIFOж */
		R8_HSPI_INT_FLAG = RB_HSPI_IF_FIFO_OV;
		DUG_PRINTF("FIFO OV\r\n");
	}

    Dbg_Idle_TimeCount = 0;
}

/*******************************************************************************
* Function Name  : BULKMode_HSPI_Test
* Description    : ģʽHSPIӿڲ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void BULKMode_HSPI_Test( void )
{
    UINT32 i,j;
    UINT32 addr;

    DUG_PRINTF("BULKMode HSPI Init\n");
    HSPI_Init( );                                                             	/* HSPIӿڳʼ */

    /* ر */
    HSPI_Tx_PackCnt = 0x00;
    HSPI_Tx_AddrTog = 0x00;
    HSPI_Rx_PackCnt = 0x00;
    HSPI_Rx_AddrTog = 0x00;
    HSPI_Tx_Status = 0x00;
    HSPI_Test_PackCount = 0x00;

    /* ䷢ */
    addr = HPSI_DMA_TX_Addr0;
    for( i = 0; i < ( ( DEF_HSPI_DMA_PACK_LEN * DEF_HSPI_BULK_BPACK_NUM ) * 2 / 1024 ); i++ )
    {
        for( j = 0; j < 1024; j++ )
        {
            *(UINT8 *)( addr + j ) = (UINT8)j;
        }
        addr += 1024;
    }

    /************************************************************************/
    DUG_PRINTF("HSPI Double Dir Test\n");
    DUG_PRINTF("HSPI Host Mode\n");

    Pic_TotalLen = ( DEF_HSPI_DMA_PACK_LEN * DEF_HSPI_BULK_BPACK_NUM ) * 2;
    Pic_SendLen = 0x00;
    Pic_Last_PackLen = Pic_TotalLen % DEF_HSPI_DMA_PACK_LEN;

    PRINT("Pic_TotalLen: %x\n", (UINT32)Pic_TotalLen );
    PRINT("Pic_Last_PackLen: %x\n", (UINT32)Pic_Last_PackLen );

    /* ԶֽڵBIT0-BIT12; BIT13: 1ĩβ  */
    R32_HSPI_UDF0 = DEF_HSPI_DMA_PACK_LEN;
    R32_HSPI_UDF1 = DEF_HSPI_DMA_PACK_LEN;
    Pack_Send_Num = 0x00;
    Pack_Recv_Num = 0x00;

    PIN_HRTS_LOW( );
    while( 1 )
    {
        /* жǷ */
        if( ( HSPI_Tx_Status == 0x00 ) && PIN_HCTS_RD( ) == 0x00 )
        {
            /* 㵱ǰͻ */
            HSPI_Tx_BurstPackNum = DEF_HSPI_BULK_BPACK_NUM;
            if( ( Pic_TotalLen - Pic_SendLen ) < ( DEF_HSPI_BULK_BPACK_NUM * DEF_HSPI_DMA_PACK_LEN ) )
            {
                HSPI_Tx_BurstPackNum = ( Pic_TotalLen - Pic_SendLen + ( DEF_HSPI_DMA_PACK_LEN - 1 ) ) / DEF_HSPI_DMA_PACK_LEN;
            }

            /* ͻģʽݷ */
            R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0 + Pic_SendLen;
            R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1 + Pic_SendLen;

            /* ݰİ */
#if( DEF_FUN_PACK_SN_EN == 0x01 )
            addr = HPSI_DMA_TX_Addr0 + Pic_SendLen;
            for( i = 0; i < ( HSPI_Tx_BurstPackNum * DEF_HSPI_DMA_PACK_LEN ) / 1024; i++ )
            {
                *(UINT8 *)( addr + 0 ) = (UINT8)( Pack_Send_Num >> 24 );
                *(UINT8 *)( addr + 1 ) = (UINT8)( Pack_Send_Num >> 16 );
                *(UINT8 *)( addr + 2 ) = (UINT8)( Pack_Send_Num >> 8 );
                *(UINT8 *)( addr + 3 ) = (UINT8)( Pack_Send_Num );
                Pack_Send_Num++;
                addr += 1024;
            }
#endif

            HSPI_Tx_PackCnt = 0x00;
            R16_HSPI_BURST_CFG = ( HSPI_Tx_BurstPackNum << 8 ) | RB_HSPI_BURST_EN;
            R8_HSPI_INT_FLAG = 0x0F;                                            /* ֮ǰHSPIжϱ־0 */
            R8_HSPI_CTRL |= RB_HSPI_SW_ACT;                                     /*  */
            HSPI_Tx_Status = 0x01;

  //        DUG_PRINTF("Send Pack\r\n");
        }

        /* ȴݷϻʧ */
        if( HSPI_Tx_Status == 0x02 )
        {
//         DUG_PRINTF("Send Success!\r\n");

            HSPI_Tx_Status = 0x00;

            /* 㷢ͳ */
            Pic_SendLen += ( HSPI_Tx_PackCnt * DEF_HSPI_DMA_PACK_LEN );

            /* : 㷢͵HSPIܳ */
            Dbg_HSPI_Tx_TLen += ( HSPI_Tx_PackCnt * DEF_HSPI_DMA_PACK_LEN );

            if( Pic_SendLen >= Pic_TotalLen )
            {
                Pic_SendLen = 0x00;
                R32_HSPI_UDF0 = DEF_HSPI_DMA_PACK_LEN;
                R32_HSPI_UDF1 = DEF_HSPI_DMA_PACK_LEN;

                /* DMAַر */
                R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0;
                R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1;
                if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
                {
                    R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
                }
                R8_HSPI_TX_SC = 0x00;
                HSPI_Tx_PackCnt = 0x00;
                HSPI_Tx_AddrTog = 0x00;
            }

            /* ͨתIOڲʱ */
            HSPI_Test_PackCount++;
            if( HSPI_Test_PackCount % 1024 == 0 )
            {
                GPIOB_InverseBits( ( 1 << 24 ) );
            }
        }
        else if( HSPI_Tx_ErrFlag )
        {
            DUG_PRINTF("Send Error!\r\n");
            HSPI_Tx_ErrFlag = 0x00;
        }
    }
}

/*******************************************************************************
* Function Name  : UVCMode_HSPI_Test
* Description    : ͬģʽHSPIӿڲ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UVCMode_HSPI_Test( void )
{
    UINT32 i,j;
    UINT32 addr;

    DUG_PRINTF("UVCMode HSPI Init\n");
    HSPI_Init( );                                                               /* HSPIӿڳʼ */

    /* ر */
    HSPI_Tx_PackCnt = 0x00;
    HSPI_Tx_AddrTog = 0x00;
    HSPI_Rx_PackCnt = 0x00;
    HSPI_Rx_AddrTog = 0x00;
    HSPI_Tx_Status = 0x00;
    HSPI_Test_PackCount = 0x00;

#if 0
    /* ȫͼƬ */
    PRINT("JPEG Size: %x\n",(UINT32)sizeof(jpeg));
    addr = HPSI_DMA_TX_Addr0;
    for( i = 0; i < sizeof(jpeg); i++ )
    {
        if( ( i % 1024 ) == 0x00 )
        {
            printf("\n");
        }
        printf("%02x ",(UINT16)( *(UINT8 *)( addr + i ) ));
    }
    printf("\n");
#endif


    /************************************************************************/
    DUG_PRINTF("HSPI Host Mode\n");
    Pic_SendLen = 0x00;
    /* ䷢ */
#if 1
    addr = HPSI_DMA_TX_Addr0;
    for(i=0;i<3;i++)
    {
        *(UINT32 *)(addr + i*4) = 0;
    }
    for( i = 3; i < ( ( DEF_HSPI_DMA_PACK_LEN * (DEF_HSPI_UVC_BPACK_NUM -1) +12 )/ 4 ); i++ )
    {
        *(UINT32 *)(addr + i*4) =Color_Elemnt[g_ColorIndex];
    }
    g_ColorIndex++;
#endif

#if 0
    addr = HPSI_DMA_TX_Addr0;
    for(i=0;i<8643;i++)
    {
      printf("%08x \n",(UINT32)(*(UINT32 *)(addr +i*4  )));
    }

#endif
    Pic_TotalLen = UVC_MICROFRAME_SIZE + 12;
    Pic_Last_PackLen = Pic_TotalLen % DEF_HSPI_DMA_PACK_LEN;
    PRINT("Pic_TotalLen: %x\n", (UINT32)Pic_TotalLen );
    PRINT("Pic_Last_PackLen: %x\n", (UINT32)Pic_Last_PackLen );
    PRINT("SIZE:%d\n",( YUV_FRAME_SIZE / UVC_MICROFRAME_SIZE )-1);
    /* ԶֽڵBIT0-BIT12; BIT13: 1ĩβ  */
    R32_HSPI_UDF0 = DEF_HSPI_DMA_PACK_LEN;
    R32_HSPI_UDF1 = DEF_HSPI_DMA_PACK_LEN;
    Pack_Send_Num = 0x00;
    Pack_Recv_Num = 0x00;
    while( 1 )
    {
        /* жǷ */
        if( ( HSPI_Tx_Status == 0x00 ) && (PIN_HCTS_RD( ) == 0x00) )
        {
            /* 㵱ǰͻ */
#if  1
            /****ɫ*****/
            if((g_ColorFill >= UVC_FRAME_RATE))
            {
                g_ColorFill=0;
                addr = HPSI_DMA_TX_Addr0;
                for(i=0;i<3;i++)
                {
                    *(UINT32 *)(addr + i*4) = 0;                     //UVCͷ 12ֽ0x00
                }
                for( i = 3; i < ( ( DEF_HSPI_DMA_PACK_LEN * (DEF_HSPI_UVC_BPACK_NUM -1) +12 )/4 ); i++ ) //ISOһ΢֡͵
                {
                    *(UINT32 *)(addr + i*4) = Color_Elemnt[g_ColorIndex];
                }
                g_ColorIndex++;
                if( g_ColorIndex >= 6)
                {
                    g_ColorIndex = 0;
                }
            }
#endif
            HSPI_Tx_BurstPackNum = DEF_HSPI_UVC_BPACK_NUM;
            if( ( Pic_TotalLen - Pic_SendLen ) < ( DEF_HSPI_UVC_BPACK_NUM * DEF_HSPI_DMA_PACK_LEN ) )
            {
                HSPI_Tx_BurstPackNum = ( Pic_TotalLen - Pic_SendLen + (DEF_HSPI_DMA_PACK_LEN-1)  ) / DEF_HSPI_DMA_PACK_LEN;
            }

            /* ͻģʽݷ */
            R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0 + Pic_SendLen;
            R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1 + Pic_SendLen;

            /* ݰİ */
#if( DEF_FUN_PACK_SN_EN == 0x01 )
#if 0
            addr = HPSI_DMA_TX_Addr0 + Pic_SendLen;
            for( i = 0; i < ( HSPI_Tx_BurstPackNum * DEF_HSPI_DMA_PACK_LEN ) / 1024; i++ )
            {
                *(UINT8 *)( addr + 0 ) = (UINT8)( Pack_Send_Num >> 24 );
                *(UINT8 *)( addr + 1 ) = (UINT8)( Pack_Send_Num >> 16 );
                *(UINT8 *)( addr + 2 ) = (UINT8)( Pack_Send_Num >> 8 );
                *(UINT8 *)( addr + 3 ) = (UINT8)( Pack_Send_Num );
                Pack_Send_Num++;
                addr += 1024;
            }
#endif
#endif
            HSPI_Tx_PackCnt = 0x00;
            R16_HSPI_BURST_CFG = ( HSPI_Tx_BurstPackNum << 8 ) | RB_HSPI_BURST_EN;
            R8_HSPI_INT_FLAG = 0x0F;                                            /* ֮ǰHSPIжϱ־0 */
            R8_HSPI_CTRL |= RB_HSPI_SW_ACT;                                     /*  */
            HSPI_Tx_Status = 0x01;

   //         DUG_PRINTF("%x\n",(UINT16)HSPI_Tx_BurstPackNum);
        }

        /* ȴݷϻʧ */
        if( HSPI_Tx_Status == 0x02 )
        {

            HSPI_Tx_Status = 0x00;

            /* 㷢ͳ */
//            Pic_SendLen += ( HSPI_Tx_PackCnt * DEF_HSPI_DMA_PACK_LEN );

            /* : 㷢͵HSPIܳ */
            Dbg_HSPI_Tx_TLen += ( HSPI_Tx_PackCnt * DEF_HSPI_DMA_PACK_LEN );

                Pic_SendLen = 0x00;
                R32_HSPI_UDF0 = DEF_HSPI_DMA_PACK_LEN;
                R32_HSPI_UDF1 = DEF_HSPI_DMA_PACK_LEN;

                /* DMAַر */
                R32_HSPI_TX_ADDR0 = HPSI_DMA_TX_Addr0;
                R32_HSPI_TX_ADDR1 = HPSI_DMA_TX_Addr1;
                if( ( R8_HSPI_TX_SC & RB_HSPI_TX_TOG ) == RB_HSPI_TX_TOG )
                {
                    R8_HSPI_TX_SC = RB_HSPI_TX_TOG;
                }
                R8_HSPI_TX_SC = 0x00;
                HSPI_Tx_PackCnt = 0x00;
                HSPI_Tx_AddrTog = 0x00;
            /* ͨתIOڲʱ */
            HSPI_Test_PackCount++;
            if( HSPI_Test_PackCount % 1024 == 0 )
            {
                GPIOB_InverseBits( ( 1 << 24 ) );
            }
        }
        else if( HSPI_Tx_ErrFlag )
        {
            DUG_PRINTF("Send Error!\r\n");
            HSPI_Tx_ErrFlag = 0x00;
        }
    }
}
